package com.googlecode.jpattern.gwt.client;

import java.util.Map;

import com.googlecode.jpattern.gwt.client.communication.AProxy;
import com.googlecode.jpattern.gwt.client.communication.ICallbackAction;
import com.googlecode.jpattern.gwt.client.serializer.IObjectSerializer;
import com.googlecode.jpattern.shared.result.facade.ICommandFacadeResult;

/**
 * 
 * @author Francesco Cina'
 *
 * 06/mag/2011
 */
public interface IServerCallService extends IService {

	<T extends ICommandFacadeResult<?>>AProxy<T> get(IObjectSerializer<T> resultClassSerializer, ICallbackAction<T> callbackAction,
			String url, Map<String, String> keyValuesMap);

	<T extends ICommandFacadeResult<?>>AProxy<T> delete(IObjectSerializer<T> resultClassSerializer, ICallbackAction<T> callbackAction,
			String url, Map<String, String> keyValuesMap);

	<T extends ICommandFacadeResult<?>,Z> AProxy<T> post(IObjectSerializer<T> resultClassSerializer, IObjectSerializer<Z> dataClassSerializer,
			ICallbackAction<T> callbackAction, String url, Z data);

	<T extends ICommandFacadeResult<?>,Z> AProxy<T> put(IObjectSerializer<T> resultClassSerializer, IObjectSerializer<Z> dataClassSerializer,
			ICallbackAction<T> callbackAction, String url, Z data);
	
}
